CREATE TABLE IF NOT EXISTS gene (
	stable_id VARCHAR(255) NOT NULL PRIMARY KEY
);

CREATE TABLE IF NOT EXISTS transcript (
	stable_id VARCHAR(255) NOT NULL PRIMARY KEY,
	paired_stable_id VARCHAR(255) NOT NULL,
	gene_stable_id VARCHAR(255) NOT NULL,
	FOREIGN KEY(gene_stable_id) REFERENCES gene(stable_id)
);

CREATE TABLE IF NOT EXISTS motif (
	name VARCHAR(255) NOT NULL PRIMARY KEY
);

CREATE TABLE IF NOT EXISTS crm (
	id BIGINT AUTO_INCREMENT PRIMARY KEY,
	transcript_stable_id VARCHAR(255) NOT NULL,
	start INTEGER NOT NULL,
	stop INTEGER NOT NULL,
	refstart INTEGER NOT NULL,
	refend INTEGER NOT NULL,
	score DECIMAL NOT NULL,
	spv DECIMAL NOT NULL,
	scorepv DECIMAL NOT NULL
);

CREATE TABLE IF NOT EXISTS occurence (
	refcrm BIGINT NOT NULL,
	refmotif VARCHAR(255) NOT NULL,
	score DECIMAL NOT NULL,
	start INTEGER NOT NULL,
	strand BOOLEAN NOT NULL,
	FOREIGN KEY(refcrm) REFERENCES crm(id),
	FOREIGN KEY(refmotif) REFERENCES motif(name)
);
