package app;

import logic.sequence.DNASequence;
import logic.sequence.io.EnsemblDBReader;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class DownloadingSequenceManager implements SequenceManager {
	private Log l = LogFactory.getLog(getClass());
	private int upstream;
	private int downstream;
	public DownloadingSequenceManager(int downstream, int upstream) {
		this.upstream = upstream;
		this.downstream = downstream;
	}
	public DNASequence getSequence(String id) {
		try {
			return EnsemblDBReader.getReader().getByStableId(id, upstream, downstream, true);
		} catch (Exception e) {
			l.error(e);
			return null;
		}
	}
}
