package app;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.LinkedList;
import java.util.List;

public final class Helpers {
	
	public static List<SequencePair> computePairs(File pairsFile) throws IOException {
		String escape = "\t";
		BufferedReader br = new BufferedReader(new FileReader(pairsFile));
		List<SequencePair> pairs = new LinkedList<SequencePair>();
		while (true) {
			String line = br.readLine();
			if (line == null)
				break;
			String[] pair = line.split(escape);
			SequencePair sp = new SequencePair(pair[0].trim(), pair[1].trim());
			pairs.add(sp);
		}
		br.close();
		return pairs;
	}
	
	public static class SequencePair {
		public final String first;
		public final String second;
		public SequencePair(String first, String second) {
			super();
			this.first = first;
			this.second = second;
		}
		
	}
}
