package app;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

import logic.sequence.DNASequence;
import logic.sequence.io.FastaSequenceReader;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class LocalSequenceManager implements SequenceManager {
	private Log l = LogFactory.getLog(getClass());
	private Map<String, DNASequence> sequences = new HashMap<String, DNASequence>();
	public LocalSequenceManager(String path) {
		File dir = new File(path);
		File[] seqFiles = dir.listFiles();
		for (File file : seqFiles) {
			try {
				for (DNASequence s : FastaSequenceReader.readDNASeqFromFile(file, true)) {
					sequences.put(s.getName(), s);
				}
			} catch (Exception e) {
				l.error(e);
			}
		}
	}

	public DNASequence getSequence(String id) {
		return sequences.get(id);
	}

}
