package app.billboard;

import java.io.File;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collection;

import logic.sequence.DNASequence;
import logic.sequence.impl.BadAlphabet;
import logic.sequence.io.FastaSequenceReader;

public class ComputeMarkovBackground {
	public static void main(String args[]) throws IOException, BadAlphabet {
		File file = new File("res/randomSet/rnorvegicus_gene_ensembl");
		File[] files = file.listFiles();
		int[][][][] bg = new int[4][4][4][4];
		char first = 'n', second = 'n', third = 'n';
		for (File file2 : files) {
			Collection<DNASequence> name = FastaSequenceReader.readDNASeqFromFile(file2, true);
			for (DNASequence sequence : name) {
				for (int i = 0; i < sequence.length(); i++) {
					char c = sequence.getAt(i);
					if (mapchar(c) != -1)
						if (mapchar(first) != -1 && mapchar(second) != -1 && mapchar(third) != -1)
							bg[mapchar(first)][mapchar(second)][mapchar(third)][mapchar(c)]++;
					first = second; second = third; third = c;
				}
			}
		}
		double[][][][] dbg = new double[4][4][4][4];
		for (int i = 0; i < 4; i++)
			for (int j = 0; j < 4; j++)
				for (int k = 0; k < 4; k++) {
					int sum = 0;
					for (int z = 0; z < 4; z++)
						sum += bg[i][j][k][z];
					for (int z = 0; z < 4; z++)
						dbg[i][j][k][z] = (bg[i][j][k][z] + 0.0) / sum;
				}
		System.out.println(Arrays.deepToString(dbg));
	}
	
	private static int mapchar(char c) {
		switch (Character.toLowerCase(c)) {
		case 'a':
			return 0;
		case 'g':
			return 1;
		case 'c':
			return 2;
		case 't':
			return 3;
		default:
			return -1;
		}
	}
	
}
