package app.billboard;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.FilenameFilter;
import java.io.IOException;

public class MatrixConverter {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		File f = new File(args[0]);
		File dest = new File(args[1]);
		File[] files = f.listFiles(new FilenameFilter() {

			public boolean accept(File dir, String name) {
				return name.endsWith(".pfm");
			}
			
		});
		
		for (File file : files) {
			BufferedReader reader = new BufferedReader(new FileReader(file));
			File res = new File(dest, file.getName());
			BufferedWriter out = new BufferedWriter(new FileWriter(res));
			String line;
			while ((line = reader.readLine()) != null) {
				String[] strings = line.split("[ \t]+");
				for (String string : strings) {
					System.out.println(string);
					int d = (int) Double.parseDouble(string);
					out.write(d + " ");
				}
				out.newLine();
			}
			out.flush();
			out.close();
			reader.close();
		}
		
	}

}
