package app.billboard.homologs;

public class Alignment {
	
	private String s2;
	private String s1;

	public Alignment(String s1, String s2) {
		this.s1 = s1; this.s2 = s2;
	}
	
	public int getScore() {
		int result = 0;
		int[][] array = new int[s1.length() + 1][s2.length() + 1];
		for (int i = 0; i < s1.length(); i++) {
			for (int j = 0; j < s2.length(); j++) {
				int s = match(s1.charAt(i), s2.charAt(j));
				array[i + 1][j + 1] = Math.max(0, 
						Math.max(array[i][j] + s,
								Math.max(array[i][j+1] - 1 + s, array[i+1][j] - 1 + s)));
				result = Math.max(result, array[i+1][j+1]);
			}
		}
		return result;
	}
	
	public int getScore2() {
		//$ANALYSIS-IGNORE
		int result = 0, last, old;
		int[] array = new int[s2.length() + 1];
		for (int i = 0; i < s1.length(); i++) {
			last = 0;
			for (int j = 0; j < s2.length(); j++) {
				int s = match(s1.charAt(i), s2.charAt(j));
				old = array[j+1];
				array[j + 1] = Math.max(0, 
						Math.max(last + s,
								Math.max(old - 1 + s, array[j] - 1 + s)));
				result = Math.max(result, array[j+1]);
				last = old;
			}
		}
		return result;
	}
	
	public double getScore3() {
		int s = getScore2();
		return (2 * (double) s) / (double) (s1.length() + s2.length());
	}

	private int match(char c, char d) {
		return c == d ? ((c == 'n' || d == 'n') ? -1 : 1) : -1;
	}
	
	

}
