package app.test;

import java.io.BufferedReader;
import java.io.IOException;
import java.util.LinkedList;
import java.util.List;
import java.util.Properties;

import app.exception.ConfigurationException;
import app.intf.Parameters;

public class ParameterParser {

	private BufferedReader source;
	private Properties p;

	public ParameterParser(BufferedReader reader, Properties p) {
		this.source = reader;
		this.p = p;
	}
	
	/**
	 * File format is: alpha	beta	gamma	frame	jump	thresholdtype	[thresholdvalue]
	 * @return
	 * @throws IOException
	 * @throws ConfigurationException 
	 */
	public List<Parameters> parse() throws IOException, ConfigurationException {
		LinkedList<Parameters> result = new LinkedList<Parameters>();
		String line;
		while ((line = source.readLine()) != null) {
			String[] ps = line.split("\t");
			if (ps.length < 5)
				throw new ConfigurationException("Could not parse parameter file!");
			double alpha = Double.parseDouble(ps[0]);
			double beta = Double.parseDouble(ps[1]);
			double gamma = Double.parseDouble(ps[2]);
			int frame = Integer.parseInt(ps[3]);
			int jump = Integer.parseInt(ps[4]);
			result.add(new Parameters(p, alpha, beta, gamma, frame, jump));
		}
		return result;
	}

}
