package app.tools;

import java.util.Random;

public class KnuthShuffle {
	public static int[] generateShuffle(int n) {
		int[] shuffle = new int[n];
		for (int i = 0; i < n; i++)
			shuffle[i] = i;
		Random r = new Random(System.currentTimeMillis());
		for (int i = 1; i < n; i++) {
			int k = r.nextInt(i);
			swap(shuffle, k, i);
		}
		return shuffle;
	}
	
	private static void swap(int[] shuffle, int k, int i) {
		if (k == i)
			return;
		int t = shuffle[i];
		shuffle[i] = shuffle[k];
		shuffle[k] = t;
	}
}
