package logic.alignment;

import logic.multiset.MultiSet;
import logic.multiset.MultiSet.CutAndDiff;

public class CutAndDiffMatrix {
	CutAndDiff[][] m;
	MultiSet[] s1, s2;
	public CutAndDiffMatrix(MultiSet[] s1, MultiSet[] s2) {
		this.s1 = s1; this.s2 = s2;
		compute();
	}
	
	public CutAndDiff[][] getComputedMatrix() {
		return m;
	}
	
	private void compute() {
		m = new CutAndDiff[s1.length][s2.length];
		for (int i = 0; i < s1.length; i++)
			for (int j = 0; j < s2.length; j++) {
				m[i][j] = s1[i].compare(s2[j]);
			}
	}
	
	public double getAverageSumProportion() {
		int sumcut = 0, sumdiff = 0;
		for (int i = 0; i < s1.length; i++)
			for (int j = 0; j < s2.length; j++) {
				sumcut += m[i][j].cut;
				sumdiff += m[i][j].diff;
			}
		return (double)sumcut/(double)sumdiff;
	}
	
	public double getAverageProportion() {
		double denominator = s1.length * s2.length;
		double numerator = 0;
		for (int i = 0; i < s1.length; i++)
			for (int j = 0; j < s2.length; j++) {
				if (m[i][j].diff != 0)
					numerator += (double)m[i][j].cut / (double)m[i][j].diff;
			}
		return numerator / denominator;
	}
	
}
