package logic.alignment;


public class SMatrix {
	private double[][] m;
	public SMatrix(CutAndDiffMatrix m, double alpha, double beta, double gamma) {
		compute(m, alpha, beta, gamma);
	}
	
	public double[][] getComputedMatrix() {
		return m;
	}
	
	public double[] getRowMax() {
		double result[] = new double[m.length];
		for (int i = 0; i < m.length; i++) {
			result[i] = Double.NEGATIVE_INFINITY;
			for (int j = 0; j < m[0].length; j++) {
				result[i] = Math.max(result[i], m[i][j]);
			}
		}
		return result;
	}
	
	private void compute(CutAndDiffMatrix cutAndDiff, double alpha, double beta, double gamma) {
		m = new double[cutAndDiff.s1.length][cutAndDiff.s2.length];
		for (int i = 0; i < cutAndDiff.s1.length; i++)
			for (int j = 0; j < cutAndDiff.s2.length; j++) {
				m[i][j] = alpha * cutAndDiff.m[i][j].cut - beta * cutAndDiff.m[i][j].diff - gamma;;
			}
	}
	
}
