package logic.alignment;


public class ScoreMatrix {
	private double[][] m;
	private double[][] ds;
	public ScoreMatrix(SMatrix s) {
		ds = s.getComputedMatrix();
		compute();
	}
	
	void compute() {
		m = new double[ds.length][ds[0].length];
		for (int i = 0; i < m.length; i++)
			m[i][0] = ds[i][0];
		for (int j = 0; j < m[0].length; j++)
			m[0][j] = ds[0][j];
		for (int i = 1; i < m.length; i++)
			for (int j = 1; j < m[0].length; j++)
				m[i][j] = Math.max(0, m[i-1][j-1] + ds[i][j]);
	}
	
	public double[] getRowMax() {
		double result[] = new double[ds.length];
		for (int i = 0; i < m.length; i++) {
			result[i] = Double.NEGATIVE_INFINITY;
			for (int j = 0; j < m[i].length; j++) {
				result[i] = Math.max(result[i], m[i][j]);
			}
		}
		return result;
	}
	
	public double[][] getResultMatrix() {
		return m;
	}
	
	public double[][] getSMatrix() {
		return ds;
	}
}
