package logic.sequence.impl;

import logic.sequence.TFSite;
import logic.tfbs.TFPattern;

public final class TFSiteImpl implements TFSite {
	
	private TFPattern pattern;
	private double score;
	private int start;
	private boolean plusStrand;
	
	public TFSiteImpl(TFPattern pattern, double score, int start, boolean plusStrand) {
		this.pattern = pattern;
		this.score = score;
		this.start = start;
		this.plusStrand = plusStrand;
	}
	
	public boolean isPlusStrand() {
		return plusStrand;
	}

	public TFPattern getPattern() {
		return pattern;
	}

	public double getScore() {
		return score;
	}

	public String key() {
		return pattern.getName();
	}

	public int getStart() {
		return start;
	}
	
	public int getEnd() {
		return start + pattern.length() - 1;
	}

	/**
	 * @generated by CodeSugar http://sourceforge.net/projects/codesugar */
	
	public String toString() {
		StringBuffer buffer = new StringBuffer();
		buffer.append("[");
		buffer.append(pattern);
		buffer.append(" s:");
		buffer.append(Math.round(100*score)/100.0);
		buffer.append(" p:");
		buffer.append(start);
		buffer.append(" strand:");
		buffer.append(plusStrand ? "+" : "-");
		buffer.append("]");
		return buffer.toString();
	}

}
