package logic.sequence.io.db;

import app.ensembl.Species;

public class Schema {
	
	public static final String HOMO = "homo_sapiens_core_47_36i";
	public static final String MUS = "mus_musculus_core_47_37";
	public static final String RAT = "rattus_norvegicus_core_47_34q";
	public static final String COMPARA = "ensembl_compara_47";
	
	public static String getHomo(String table) {
		return HOMO + "." + table;
	}
	
	public static String getMus(String table) {
		return MUS + "." + table;
	}
	
	public static String getRat(String table) {
		return RAT + "." + table;
	}
	
	public static String getCompara(String table) {
		return COMPARA + "." + table;
	}
	
	public static String getSpecies(String table, Species s) {
		if (s == Species.HOMO_SAPIENS) {
			return getHomo(table);
		} else if (s == Species.MUS_MUSCULUS){
			return getMus(table);
		} else if (s == Species.RATTUS_NORVEGICUS) {
			return getRat(table);
		} else {
			return null;
		}
	}
	
	public static int getGenomeDbId(Species s) {
		if (s == Species.HOMO_SAPIENS)
			return 22;
		else
			return 57; // mouse
	}
}
