package logic.sequence.io.db.sql.entity;

import logic.sequence.io.db.sql.entity.manager.EntityManager;
import logic.sequence.io.db.sql.entity.manager.ExonManager;


/**
 * "select a.exon_id, a.seq_region_id, a.seq_region_start, a.seq_region_end," +
				" a.seq_region_strand 
 * @author Mateusz
 *
 */

public class Exon {
	public final int exonId;
	public final int seqRegionId;
	public final int seqRegionStart;
	public final int seqRegionEnd;
	public final boolean seqRegionStrand;
	public Exon(final int exonId, final int seqRegionId, final int seqRegionStart, final int seqRegionEnd, final boolean b) {
		super();
		this.exonId = exonId;
		this.seqRegionId = seqRegionId;
		this.seqRegionStart = seqRegionStart;
		this.seqRegionEnd = seqRegionEnd;
		this.seqRegionStrand = b;
	}
	
	public static EntityManager<Exon> getEntityManager() {
		return new ExonManager();
	}
	
	/**
	 * @generated by CodeSugar http://sourceforge.net/projects/codesugar */
	
	public String toString() {
		StringBuffer buffer = new StringBuffer();
		buffer.append("[Exon:");
		buffer.append(" exonId: ");
		buffer.append(exonId);
		buffer.append(" seqRegionId: ");
		buffer.append(seqRegionId);
		buffer.append(" seqRegionStart: ");
		buffer.append(seqRegionStart);
		buffer.append(" seqRegionEnd: ");
		buffer.append(seqRegionEnd);
		buffer.append(" seqRegionStrand: ");
		buffer.append(seqRegionStrand);
		buffer.append("]");
		return buffer.toString();
	}

	/**
	 * Returns <code>true</code> if this <code>Exon</code> is the same as the o argument.
	 *
	 * @return <code>true</code> if this <code>Exon</code> is the same as the o argument.
	 */
	public boolean equals(Object o) {
		if (this == o) {
			return true;
		}
		if (o == null) {
			return false;
		}
		if (o.getClass() != getClass()) {
			return false;
		}
		Exon castedObj = (Exon) o;
		return this.exonId == castedObj.exonId;
	}

	/**
	 * Override hashCode.
	 *
	 * @return the Objects hashcode.
	 */
	public int hashCode() {
		return new Integer(exonId).hashCode();
	}

}
