package logic.sequence.io.db.sql.entity;

import logic.sequence.io.db.sql.entity.manager.EntityManager;
import logic.sequence.io.db.sql.entity.manager.GenomicAlignManager;

public class GenomicAlign {
	public final long genomic_align_id;
	public final long genomic_align_block_id;
	public final int dnafrag_id;
	public final int dnafrag_start;
	public final int dnafrag_end;
	public final boolean dnafrag_strand;
	public final String cigar_line;
	public GenomicAlign(long genomic_align_id, long genomic_align_block_id,
			int dnafrag_id, int dnafrag_start, int dnafrag_end, boolean dnafrag_strand, String cigar_line) {
		super();
		this.genomic_align_id = genomic_align_id;
		this.genomic_align_block_id = genomic_align_block_id;
		this.dnafrag_id = dnafrag_id;
		this.dnafrag_start = dnafrag_start;
		this.dnafrag_end = dnafrag_end;
		this.dnafrag_strand = dnafrag_strand;
		this.cigar_line = cigar_line;
	}
	
	public boolean equals(GenomicAlign other) {
		return this.genomic_align_id == other.genomic_align_id;
	}
	
	public static EntityManager<GenomicAlign> getEntityManager() {
		return new GenomicAlignManager();
	}
}
