package logic.sequence.io.db.sql.entity;

import logic.sequence.io.db.sql.entity.manager.EntityManager;
import logic.sequence.io.db.sql.entity.manager.TranscriptManager;


/**
 * "select a.transcript_id, a.gene_id, a.seq_region_id, a.seq_region_start," +
				" a.seq_region_end, a.seq_region_strand
 * @author Mateusz
 *
 */
public class Transcript {
	public final int transcriptId;
	public final int geneId;
	public final int seqRegionId;
	public final int seqRegionStart;
	public final int seqRegionEnd;
	public final boolean seqRegionStrand;
	public final String stableId;
	public Transcript(final int transcriptId, final int geneId, final int seqRegionId, final int seqRegionStart, final int seqRegionEnd, final boolean seqRegionStrand, final String stableId) {
		super();
		this.transcriptId = transcriptId;
		this.geneId = geneId;
		this.seqRegionId = seqRegionId;
		this.seqRegionStart = seqRegionStart;
		this.seqRegionEnd = seqRegionEnd;
		this.seqRegionStrand = seqRegionStrand;
		this.stableId = stableId;
	}
	
	public static EntityManager<Transcript> getEntityManager() {
		return new TranscriptManager();
	}
	
	/**
	 * @generated by CodeSugar http://sourceforge.net/projects/codesugar */
	
	public String toString() {
		StringBuffer buffer = new StringBuffer();
		buffer.append("[Transcript:");
		buffer.append(" transcriptId: ");
		buffer.append(transcriptId);
		buffer.append(" geneId: ");
		buffer.append(geneId);
		buffer.append(" seqRegionId: ");
		buffer.append(seqRegionId);
		buffer.append(" seqRegionStart: ");
		buffer.append(seqRegionStart);
		buffer.append(" seqRegionEnd: ");
		buffer.append(seqRegionEnd);
		buffer.append(" seqRegionStrand: ");
		buffer.append(seqRegionStrand);
		buffer.append(" stableId: ");
		buffer.append(stableId);
		buffer.append("]");
		return buffer.toString();
	}

}
