package logic.tfbs;

import java.util.Iterator;

public class PatternSet implements Iterable<TFPattern> {
	
	private String name;
	private TFPattern[] patterns;

	public PatternSet(String name, TFPattern[] patterns) {
		this.name = name;
		this.patterns = patterns;
	}
	
	public int getSize() {
		return patterns.length;
	}
	
	public TFPattern getAt(int i) {
		return patterns[i];
	}
	
	public String getName() {
		return name;
	}

	public Iterator<TFPattern> iterator() {
		return new Iterator<TFPattern>() {
			private int currentIndex = 0;
			
			public boolean hasNext() {
				return currentIndex < patterns.length;
			}
			public TFPattern next() {
				return patterns[currentIndex++];
			}
			public void remove() {
				throw new UnsupportedOperationException();
			}
		};
	}

}
