package logic.tfbs.impl;

import java.util.Arrays;


public class Background {
	private char[] alphabet;
	private double[] distribution;

	public Background(char[] alphabet, double[] distribution) {
		this.alphabet = alphabet;
		this.distribution = distribution;
	}
	
	public double getForLetter(char l) throws NoSuchLetter {
		for (int i = 0; i < alphabet.length; i++) {
			if (l == alphabet[i]) {
				return distribution[i];
			}
		}
		throw new NoSuchLetter(l);
	}
	
	public static Background getUniformBackground(char[] alphabet) {
		int size = alphabet.length;
		double[] d = new double[size];
		Arrays.fill(d, 1.0/(double) size);
		return new Background(alphabet, d);
	}
}
